extern Image shadowMap;
extern mat4 shadowView;
extern mat4 shadowProj;

extern int debug = 0;
varying vec4 FragPosDepthSpace;

#ifdef VERTEX
extern mat4 model;
extern mat4 view;
extern mat4 proj;

vec4 position(mat4 transform, vec4 vertex) {
  FragPosDepthSpace = shadowProj * shadowView * model * vertex;
  return (proj * view * model) * vertex;
}
#endif

#ifdef PIXEL
vec4 effect(vec4 color, Image tex, vec2 tex_coords, vec2 screen_coords)
{
  vec4 texel = Texel(tex, tex_coords.xy); // texture_coords);
  if (texel.a < 0.1) { discard; };

  // vec3 projCoords = FragPosDepthSpace.xyz;
  vec3 projCoords = (FragPosDepthSpace.xyz / FragPosDepthSpace.w) * 0.5 + 0.5;
  float closestDepth = Texel(shadowMap, projCoords.xy).r;
  float currentDepth = projCoords.z; // why `1-` ?

  if (debug == 1) {
    return vec4(closestDepth, 0, 0, 1);
  } else if (debug == 2) {
    return vec4(0, currentDepth, 0, 1);
  }

  // shadow
  float bias = 0.002;
  float shadow = 0.0;
  if (currentDepth > closestDepth + bias) {
    shadow = 0.5; // shadow
  }

  vec4 texel_shadow = Texel(shadowMap, tex_coords.xy);
  return vec4((texel * color * (1-shadow)).rgb, 1);
}
#endif
